# 한 프로그램 내에서 일을 하는게 여러가지가 있다. ui에 관련된 것은 속도가 느리다. 이런 것은 따로 실행하게 할 필요가 있다. 
# 스레드: 프로그램에서 작업을 분할해가지고 여러 코어에서 일을 하게 하는 것
# 프라이빗 함수: _를 붙여서 외부에서 접속을 못하게 하는 함수/ 생성자도 프라이빗 함수에 속함

import tkinter as tk
from tkinter import ttk
from tkinter import scrolledtext
from tkinter import Menu
from tkinter import messagebox as msg
from time import sleep
import Tooltip as tt
            
def create_ToolTip(widget, text):
        toolTip=tt.ToolTip(widget)
        def enter(event):
            toolTip.show_tip(text)
        def leave(event):
            toolTip.hide_tip()
        widget.bind("<Enter>",enter)
        widget.bind("<Leave>",leave)            
            
class OOP():
    def __init__(self):
        self.win=tk.Tk()
        self.win.title("Python GUI")
        create_ToolTip(self.win, "Hello GUI")
        self.create_widgets()
    
    # (help메뉴 콜백) 메시지박스 함수
    def _msgBox(self):
        ret =msg.askyesno("Askyesno Messagr Box", "Is it correct?")
        if ret >0: # 왼쪽 버튼 클릭시 리턴값이 0초과인 듯 함
            print("RETRY")
        else:
            print("CANCEL")
            
    # (버튼 콜백) 버튼 설정 변경 함수
    def click_me(self):
        self.action.configure(text="Hello"+self.name.get()+''+self.number.get())
        
    # (콤보박스 콜백) 스크롤드 텍스트 출력 함수
    def print_Combobox(self,event):
        self.scr.insert(tk.INSERT, "The selected number of Combobox is "+self.number.get()+'.\n')
        
    # (스핀 콜백) 스크롤드텍스트 출력 함수
    def _spin(self):
        value=self.spin.get()
        self.scr.insert(tk.INSERT, value+'\n')
        
    def run_progressbar(self):
        self.progress_bar['maximum']=100
        for i in range(101):
            sleep(0.05)
            self.progress_bar['value']=i
            self.progress_bar.update()
        self.progress_bar['value']=0
        
    def start_progressbar(self):
        self.progress_bar.start()
        
    def stop_progressbar(self):
        self.progress_bar.stop()
        
    def progressbar_stop_after(self,wait_ms=1000):
        self.win.after(wait_ms,self.progress_bar.stop)
        
    def radCall(self):
        redsel=self.radVar.get()
        self.mighty2.configure(text=self.colors[redsel]) # 라디오버튼 클릭시 라벨프레임 텍스트 변경
   
    
    def create_widgets(self):
        # 메뉴 생성
        menu_bar = Menu(self.win)
        self.win.config(menu=menu_bar) 
    
        # 메뉴 아이템 생성
        file_menu = Menu(menu_bar,tearoff=0) # 메뉴안에 메뉴를 생성=>(메뉴 안) 아이템칸 생성
        file_menu.add_command(label="New") # 아이템 추가
        file_menu.add_command(label="Exit",command=self.win.quit) # 아이템 추가 및 입력 받을 시 콜백함수 호출
        file_menu.add_separator()
        menu_bar.add_cascade(label="File",menu=file_menu)
        
        help_menu=Menu(menu_bar, tearoff=0)
        menu_bar.add_cascade(label="Help",menu=help_menu)
        help_menu.add_command(label="About",command=self._msgBox) 
    
        # 탭 생성에 필요한 탭 컨트롤 생성
        tabControl=ttk.Notebook(self.win)
        
        # 새로운 탭(탭1) 추가
        tab1=ttk.Frame(tabControl)
        tabControl.add(tab1, text="Tab1")
        
        # 새로운 탭(탭2) 추가
        tab2=ttk.Frame(tabControl)
        tabControl.add(tab2, text="Tab2")
        
        # 새로운 탭(탭3) 추가
        tab3=ttk.Frame(tabControl)
        tabControl.add(tab3, text="Tab3")
        
        # grid메소드과  비슷, fill은 제공된 공간을 점유하도록 지정, expand는 여분의 공간을 채우기 위해 확장할건지
        tabControl.pack(expand=1,fill="both") 
        
        # tab1에 라벨프레임 생성
        mighty= ttk.LabelFrame(tab1,text="Mighty python")
        mighty.grid(column=0, row=0,padx=8,pady=4)
        
        
        # (tab1-라벨프레임 내) 라벨 생성
        a_label=ttk.Label(mighty,text="Enter a name:")
        a_label.grid(column=0, row=0,sticky='W')
        
        # (tab1-라벨프레임 내) 엔트리 위젯
        self.name= tk.StringVar()
        self.name_entered = ttk.Entry(mighty, width=12, textvariable=self.name)
        self.name_entered.grid(column=0, row=1)        
        
        # (tab1-라벨프레임 내) 버튼 위젯
        self.action=ttk.Button(mighty, text="Click Me!", command=self.click_me)
        self.action.grid(column=2, row=1)
        
        # (tab1-라벨프레임 내) 라벨 생성
        ttk.Label(mighty,text="Choose a number").grid(column=1,row=0)
        
        # (tab1-라벨프레임 내) 콤보박스 위젯
        self.number=tk.StringVar()
        self.number_chosen=ttk.Combobox(mighty,width=12,textvariable=self.number, state= 'readonly')
        self.number_chosen['values']=(1,2,4,42,100)
        self.number_chosen.grid(column=1,row=1)
        self.number_chosen.current(0)
        self.number_chosen.bind("<<ComboboxSelected>>",self.print_Combobox)
        
        # (tab1-라벨프레임 내) 스핀박스
        self.spin=tk.Spinbox(mighty,values=(1,2,4,42,100),width=5,bd=8,command=self._spin)
        self.spin.grid(column=0,row=2)
        create_ToolTip(self.spin,'This is a spincontrol')
        
        self.spin2=tk.Spinbox(mighty,values=(0,50,100),width=5,bd=9,relief=tk.FLAT) # relief는 스핀박스 테두리를 디자인하는 메소드
        self.spin2.grid(column=1,row=2)
        
        # (tab1-라벨프레임 내) 스크롤드 테스트  위젯
        scrol_w = 30
        scrol_h =3
        self.scr = scrolledtext.ScrolledText(mighty, width=scrol_w, height=scrol_h, wrap=tk.WORD)
        self.scr.grid(column=0, columnspan=3, row=3, sticky='WE')
        create_ToolTip(self.scr,'This is a ScrolledText widget')
        
        
        # (tab1-라벨프레임 내) 그리드 설정 변경
        for child in mighty.winfo_children():
            child.grid_configure(sticky='W')
            
        # tab2에 라벨프레임 생성
        self.mighty2= ttk.LabelFrame(tab2,text="The Snake")
        self.mighty2.grid(column=0, row=0,padx=8,pady=4)
            
        # (tab2-라벨프레임 내) 체크버튼 위젯
        chVarDis=tk.IntVar()
        check1 = tk.Checkbutton(self.mighty2, text="Disabled",variable=chVarDis,state="disabled")
        check1.select()
        check1.grid(column=0, row=0, sticky=tk.W)
        
        chVarUn=tk.IntVar()
        check2 = tk.Checkbutton(self.mighty2, text="UnChecked",variable=chVarUn)
        check2.deselect()
        check2.grid(column=1, row=0, sticky=tk.W)
        
        chVarEn=tk.IntVar()
        check3 = tk.Checkbutton(self.mighty2, text="Enabled",variable=chVarEn)
        check3.select()
        check3.grid(column=2, row=0, sticky=tk.W)
        
        # (tab2-라벨프레임 내) 라디오버튼 위젯
        self.colors=["Blue","Gold","Red"]
        self.radVar = tk.IntVar()
        self.radVar.set(99)
        
        for col in range(3):
            curRad=tk.Radiobutton(self.mighty2,text=self.colors[col], variable =self.radVar,value=col, command=self.radCall)
            curRad.grid(column=col, row=1, sticky=tk.W)
        
        # (tab2-라벨프레임 내) 라벨 프레임 위젯
        buttons_frame = ttk.Labelframe(self.mighty2, text='Labels in a Frame')
        buttons_frame.grid(column=0, row=2)
        
        ttk.Button(buttons_frame,text="Run Progressbar",command=self.run_progressbar).grid(column=0,row=0,sticky='W')
        ttk.Button(buttons_frame,text="Start Progressbar",command=self.start_progressbar).grid(column=0,row=1,sticky='W')
        ttk.Button(buttons_frame,text="Stop Progressbar",command=self.stop_progressbar).grid(column=0,row=2,sticky='W')
        ttk.Button(buttons_frame,text="Stop after second",command=lambda:self.progressbar_stop_after(2000)).grid(column=0,row=3,sticky='W')
        
        self.progress_bar=ttk.Progressbar(tab2,orient='horizontal',length=286,mode='determinate')
        self.progress_bar.grid(column=0,row=3,pady=2)
    
        # (tab3 내) 프레임 위젯 생성
        tab3_frame=tk.Frame(tab3,bg='blue')
        tab3_frame.pack()
        
        # (tab3-프레임 내) 캔버스 위젯 생성
        canvas1=tk.Canvas(tab3_frame,width=150,height=80,highlightthickness=0,bg='orange')
        canvas1.grid(row=0,column=0)
        
        canvas2=tk.Canvas(tab3_frame,width=150,height=80,highlightthickness=0,bg='orange')
        canvas2.grid(row=1,column=1)
        
        # (tab3-프레임 내) 캔버스 위젯 내 라인과 부채꼴 주기
        coord=10,10,140,70
        arc=canvas1.create_arc(coord,start=0,extent=120,fill='red')
        line=canvas2.create_line(coord,width=5,fill='green')
        
        # 엔트리 위젯에 포커스하기 
        self.name_entered.focus()


oop=OOP()
# 이벤트순환문 실행
oop.win.mainloop()